#ifndef __UTS_H__  // __UTS_H__
#define __UTS_H__

#include <string.h>
#include <math.h>
#include "types.h"

void delay(fp_t t);

static __inline int pack_int(char *p,int &i)
{
  memcpy(p,&i,sizeof(int));
  return sizeof(int);
}

static __inline int unpack_int(char *p,int &i)
{
  memcpy(&i,p,sizeof(int));
  return sizeof(int);
}

static __inline int pack_chr(char *p,char *q,int n)
{
  memcpy(p,q,n);
  return n;
}

static __inline int unpack_chr(char *p,char *q,int n)
{
  memcpy(q,p,n);
  return n;
}

static __inline fp_t sqr(fp_t x)
{
  return x*x;
}

static __inline int sqr(int x)
{
  return x*x;
}

static __inline void swap(int &a,int &b)
{
  int c=a;
  a=b;
  b=c;
}

static __inline void swap(float32_t &a,float32_t &b)
{
  fp_t c=a;
  a=b;
  b=c;
}

static __inline void swap(float64_t &a,float64_t &b)
{
  fp_t c=a;
  a=b;
  b=c;
}

static __inline fp_t sign(fp_t f)
{
  return (f>=0.0)?1.0:-1.0;
}

static __inline fp_t sign(fp_t a,fp_t b)
{
  return (b>=0.0)?fabs(a):-fabs(a);
}

static __inline fp_t max(float32_t a,float32_t b)
{
  return (a>b)?a:b;
}

static __inline fp_t min(float32_t a,float32_t b)
{
  return (a>b)?b:a;
}

static __inline fp_t max(float64_t a,float64_t b)
{
  return (a>b)?a:b;
}

static __inline fp_t min(float64_t a,float64_t b)
{
  return (a>b)?b:a;
}

static __inline int max(int a,int b)
{
  return (a>b)?a:b;
}

static __inline int min(int a,int b)
{
  return (a>b)?b:a;
}

static __inline fp_t dsh(fp_t prv,fp_t nu_0)
{
#define C 3E10
  return nu_0*(1.0+prv/C); // Approximate but close enough!
#undef C
}

void bswap(int16_t *x,int n);
void bswap(int32_t *x,int n);
void bswap(int64_t *x,int n);
void bswap(float32_t *x,int n);
void bswap(float64_t *x,int n);

void swap(char &a,char &b);
void swap(int08_t &a,int08_t &b);
void swap(int64_t *x,int n);
void swap(int32_t *x,int n);
void swap(int16_t *x,int n);

void sort(int *x,int nx);
void sort(int *x,int *y,int nx);
void sort(fp_t *x,int *y,int nx);

void get_numbers(char *numbers,int *&img_num,int &ni);
void get_numbers(char *numbers,fp_t *&data,int &nd);
void get_number(char*,int&);
void get_number(char *number,fp_t &fpnum);

#endif             // __UTS_H__
