#ifndef __CONFIG_H__ // __CONFIG_H__
#define __CONFIG_H__

#define CMDOPTS {\
                 "-clock                                                 h\"-clock: render clock\"",\
                 "-csize               s\"<none>\"                       h\"-csize: size of clock in pixels [99]\"",\
                 "-cpos                s\"<none>\"                       h\"-cpos: position of clock [size/2,size/2]\"",\
                 "-ccol                s\"<none>\"                       h\"-ccol: color of clock [inverse]\"",\
                 "-cfg|--config        s\"<none>\"                       h\"-cfg --config <filename>: specify an alternative configuration file from the default \"defaults.dat\".\nThis file contains command line options as they should be specified on the command line. It is read before processing the command line and can be used to change the built-in default values of various program parameters.\"",\
                 "-t|--type            s\"<none>\"                       h\"-t --type: files are of type <type> [auto].\"",\
                 "-n|--nthread         i\"20\"                           h\"-n --thread: number of threads to use.\"",\
                 "-o|--off             i\"0\"                            h\"-o --off: state in the cycle.\"",\
                 "-m|--mod             i\"1\"                            h\"-m --mod: length of the cycle after division.\"",\
                 "-u|--mul             i\"1\"                            h\"-u --mul: length of one state.\"",\
                 "-ll|--wlmin          oi\"<none>\"                      h\"-ll --wlmin: first wavelength to process.\"",\
                 "-lh|--wlmax          oi\"<none>\"                      h\"-lh --wlmax: last wavelength to process.\"",\
                 "-lr|--lucyrich       os\"<none>\"                      h\"-lr --lucyrich list #: perform # Lucy-Richardson iterations, write each intermediate number.\"",\
                 "--lrbase             os\"<none>\"                      h\"--lrbase <name>: image file base for result.\"",\
                 "--imgbase            os\"<none>\"                      h\"--imgbase <name>: output image file name.\"",\
                 "--mask               os\"<none>\"                      h\"--mask <name>: wavelength independent mask to apply to the raw data.\"",\
                 "--raw                os\"rawdata\"                     h\"--raw <name>: directory containing the raw data files.\"",\
                 "--rhsname            os\"<none>\"                      h\"--rhsname <name>.\"",\
                 "-a                                                     h\"-a: read matrix from file.\"",\
                 "--lhsname            os\"<none>\"                      h\"--lhsname <name>.\"",\
                 "-r                                                     h\"-r: read rhs from file.\"",\
                 "-dx                  od\"<none>\"                      h\"-dx: shift PSF by this amount in the x direction [in pixels].\"",\
                 "-dy                  od\"<none>\"                      h\"-dy: shift PSF by this amount in the y direction [in pixels].\"",\
                 "-di                   i\"<none>\"                      h\"-di: number of exposures between subsequent restored frames.\"",\
                 "-aw                   i\"<none>\"                      h\"-aw: number of restored frames to use for running average.\"",\
                 "-h|--help            os\"<none>\"                      h\"Usage: mihirestore [options]. Options are:\n\n    -cfg --config <filename>\n    -h --help [option]\n    -q --quiet\n    -v --verbose -V\n\nUse -h <option> for more details.\n\"",\
                 "-q|--quiet                                             h\"-q --quiet: decrease verbosity\"",\
                 "-v|--verbose|-V                                        h\"-v --verbose -V: increase verbosity\"",\
                 "-s|--save                                              h\"-s --save: save intermediate stuff\"",\
                 "--noff                                                 h\"--noff: disable flatfield correction\"",\
                 "--noslv                                                h\"--noslv: do not solve the linear system\"",\
                 "--nolhs                                                h\"--nolhs: do not compute the LHS\"",\
                 "--norhs                                                h\"--norhs: do not compute or read the RHS\"",\
                 0}

#define CMDMAPS {\
                 0}

#endif                // __CONFIG_H__
