#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/socket.h>

#include "cmdln.h"
#include "uts.h"
#include "io.h"

io_class::io_class(void)
{
  level_mask=~(0xFFFFFFFF<<IOL_DEFAULT);
  f=stdout;
}

io_class::io_class(int sock_in,byte iocmd_in,cmdln &cmd)
{
  int v,q;
  cmd.get("-v",v);
  cmd.get("-q",q);
  level_mask=~(0xFFFFFFFF<<max(v-q+IOL_DEFAULT,0));
  sock=sock_in;
  f=0;
  iocmd=iocmd_in;
}

io_class::io_class(cmdln &cmd)
{
  int v,q;
  cmd.get("-v",v);
  cmd.get("-q",q);
  level_mask=~(0xFFFFFFFF<<max(v-q+IOL_DEFAULT,0));
  f=stderr;
}

io_class::~io_class(void)
{
}

int io_class::msg(int type,const char *formatstring,...)
{
  const char *message[]={"","error","warning","","info","extra info","debug level 1","debug level 2","",""};
  int msg_type=type&level_mask;
  int level=0;
  while(msg_type>>level) ++level;
  if(msg_type){
    va_list ap;
    va_start(ap,formatstring);
    char *newformatstring;
    if(!(type&IOL_NOID)){
      newformatstring=new char [strlen(formatstring)+strlen(message[level])+3];
      sprintf(newformatstring,"%s%s%s",message[level],(strlen(message[level]))?": ":"",formatstring);
    }else newformatstring=strcpy(new char [strlen(formatstring)+1],formatstring);
    if(f){
      vfprintf(f,newformatstring,ap);
      fflush(f);
    }else{
      char *str=new char [10000];    // not so nice...
      vsprintf(str+sizeof(int),newformatstring,ap);
      int size=strlen(str+sizeof(int))+sizeof(int)+1;
      ((int*)str)[0]=(type&level_mask);
      ::send(sock,&iocmd,1,0);
      ::send(sock,&size,sizeof(size),0);
      ::send(sock,str,size,0);
      delete str;
    }
    delete[] newformatstring;
    va_end(ap);
    if(msg_type&IOL_ERROR) exit(1);
  }
  return 0;
}
